import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { Prefix } from 'src/app/models/prefix.model';
import { PrefixService } from 'src/app/services/prefix.service';
import {FormControl} from '@angular/forms';
import {Observable} from 'rxjs';
import {map, startWith} from 'rxjs/operators';
import { NotifierService } from "angular-notifier";


@Component({
  selector: 'app-prefix-details',
  templateUrl: './prefix-details.component.html',
  styleUrls: ['./prefix-details.component.scss']
  
})
export class PrefixDetailsComponent implements OnInit {
  simpleprefixControl = new FormControl();
  simpleprefix:string[] = [];
  simpleprefixfilteredOptions: Observable<string[]>;
  
  subjectsControl = new FormControl();
  subjects:string[] = [];
  subjectsfilteredOptions: Observable<string[]>;
  
  verbs = [];
  objects = [];
  logic_con = [];

  public static id: any [] = [];
  private readonly notifier: NotifierService;

  //for the moment only one prefix can showed/updates
  currentprefix: Prefix  = {
    prefix: "",
    system_fun_item: "",
    state_or_verb: "",
    item_function_flow_statevalue: "",
    logical_expression: "",
    logic_connective: "",
    simple_prefix: "",
  };
  message = '';
  

  constructor(private prefixService: PrefixService,private route: ActivatedRoute,
    private router: Router, notifierService: NotifierService) { this.notifier = notifierService;
      this.simpleprefixfilteredOptions = this.simpleprefixControl.valueChanges.pipe(
        startWith(""),
        map(value => this._filter(this.simpleprefix, value))
      );
      this.subjectsfilteredOptions = this.subjectsControl.valueChanges.pipe(
        startWith(""),
        map(value => this._filter(this.subjects, value))
      );
     }

  ngOnInit(): void { 
    this.getchoices(); 
    for (let i=0; i<PrefixDetailsComponent.id.length; i++)
    {
      this.getPrefix(this.route.snapshot.params.id, PrefixDetailsComponent.id[i]);
    };
  }
   
  private _filter(data:string[], value: string): string[] {
    const filterValue = value.toLowerCase();
    this.currentprefix.prefix = this.simpleprefixControl.value;
    this.currentprefix.system_fun_item = this.subjectsControl.value;

    return data.filter(option => option.toLowerCase().indexOf(filterValue) === 0);
  }
  

  getPrefix(prefix: any, id: string): void {
    //PrefixDetailsComponent.id = id;
    this.prefixService.get(prefix, id)
      .subscribe(
        data => {
          this.currentprefix = data;
          console.log(data)
          this.simpleprefixControl.setValue(this.currentprefix.prefix);
          //make it null need solution
          //this.subjectsControl.setValue(this.currentprefix.system_fun_item);

        },
        error => {
          console.log(error);
        });
  }


  updatePrefix(): void {
    for (let i=0; i<PrefixDetailsComponent.id.length; i++){
    this.prefixService.update(this.route.snapshot.params.id, PrefixDetailsComponent.id[i], this.currentprefix)
      .subscribe(
        response => {
          console.log(response);
          this.message = response.message;
        },
        error => {
          console.log(error);
          this.notifier.notify("warning",(JSON.stringify(error["error"])));
        });}
  }
  

  getchoices(): void{
  this.prefixService.getsimpleprefix()
    .subscribe(
      data => {
        for (let x=0; x < data.length; x++ ){
        this.simpleprefix.push(data[x][1]);}
        //this.simpleprefix = data;
      },
      error => {
        console.log(error);
      });
  this.prefixService.getlogcon()
    .subscribe(
      data => {
        this.logic_con = data;
      },
      error => {
        console.log(error);
      });
  this.prefixService.getverb()
    .subscribe(
      data => {
        this.verbs = data;
      },
      error => {
        console.log(error);
      });
  this.prefixService.getsubject()
    .subscribe(
      data => {
        for (let x=0; x < data.length; x++ ){
          this.subjects.push(data[x][1]);}
        //this.subjects = data;
      },
      error => {
        console.log(error);
      });
  this.prefixService.getoobject()
    .subscribe(
      data => {
        this.objects = data;
      },
      error => {
        console.log(error);
      });
  }
}
